Index: kernel/arch/sparc64/src/mm/sun4v/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/as.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/mm/sun4v/as.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2006 Jakub Jermar
- * Copyright (c) 2009 Pavel Rimsky
  * All rights reserved.
  *
@@ -35,5 +34,4 @@
 
 #include <arch/mm/as.h>
-#include <arch/mm/pagesize.h>
 #include <arch/mm/tlb.h>
 #include <genarch/mm/page_ht.h>
@@ -41,5 +39,4 @@
 #include <debug.h>
 #include <config.h>
-#include <arch/sun4v/hypercall.h>
 
 #ifdef CONFIG_TSB
@@ -89,5 +86,5 @@
 {
 #ifdef CONFIG_TSB
-	size_t cnt = (TSB_ENTRY_COUNT * sizeof(tsb_entry_t)) >> FRAME_WIDTH;
+	count_t cnt = (TSB_ENTRY_COUNT * sizeof(tsb_entry_t)) >> FRAME_WIDTH;
 	frame_free((uintptr_t) as->arch.tsb_description.tsb_base);
 	return cnt;
@@ -115,23 +112,4 @@
 {
 	mmu_secondary_context_write(as->asid);
-#ifdef CONFIG_TSB	
-	uintptr_t base = ALIGN_DOWN(config.base, 1 << KERNEL_PAGE_WIDTH);
-
-	ASSERT(as->arch.tsb_description.tsb_base);
-	uintptr_t tsb = PA2KA(as->arch.tsb_description.tsb_base);
-		
-	if (!overlaps(tsb, 8 * MMU_PAGE_SIZE, base, 1 << KERNEL_PAGE_WIDTH)) {
-		/*
-		 * TSBs were allocated from memory not covered
-		 * by the locked 4M kernel DTLB entry. We need
-		 * to map both TSBs explicitly.
-		 */
-		mmu_demap_page(tsb, 0, MMU_FLAG_DTLB);
-		dtlb_insert_mapping(tsb, KA2PA(tsb), PAGESIZE_64K, true, true);
-	}
-
-	__hypercall_fast2(MMU_TSB_CTXNON0, 1, KA2PA(&(as->arch.tsb_description)));
-	
-#endif
 }
 
@@ -156,7 +134,7 @@
 	uintptr_t base = ALIGN_DOWN(config.base, 1 << KERNEL_PAGE_WIDTH);
 
-	ASSERT(as->arch.tsb_description.tsb_base);
+	ASSERT(as->arch.itsb && as->arch.dtsb);
 
-	uintptr_t tsb = PA2KA(as->arch.tsb_description.tsb_base);
+	uintptr_t tsb = (uintptr_t) as->arch.itsb;
 		
 	if (!overlaps(tsb, 8 * MMU_PAGE_SIZE, base, 1 << KERNEL_PAGE_WIDTH)) {
@@ -166,5 +144,5 @@
 		 * to demap the entry installed by as_install_arch().
 		 */
-		__hypercall_fast3(MMU_UNMAP_PERM_ADDR, tsb, 0, MMU_FLAG_DTLB);
+		dtlb_demap(TLB_DEMAP_PAGE, TLB_DEMAP_NUCLEUS, tsb);
 	}
 #endif
Index: kernel/arch/sparc64/src/mm/sun4v/frame.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/frame.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/mm/sun4v/frame.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -41,4 +41,6 @@
 #include <macros.h>
 
+uintptr_t last_frame = NULL;
+
 /** Create memory zones according to information stored in bootinfo.
  *
@@ -66,4 +68,6 @@
 			    SIZE2FRAMES(ALIGN_DOWN(size, FRAME_SIZE)),
 			    confdata, 0);
+			last_frame = max(last_frame, start + ALIGN_UP(size,
+			    FRAME_SIZE));
 		}
 
@@ -76,4 +80,7 @@
 		frame_mark_unavailable(ADDR2PFN(KA2PA(PFN2ADDR(0))), 1);
 	}
+
+//MH
+//	end_of_identity = PA2KA(last_frame);
 }
 
Index: kernel/arch/sparc64/src/mm/sun4v/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/tlb.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/mm/sun4v/tlb.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -89,5 +89,5 @@
  * field of the MMU fault status area is i.
  */
-static const char *fault_types[] = {
+char *fault_types[] = {
 	"unknown",
 	"fast miss",
@@ -107,4 +107,5 @@
 	"invalid page size"
 	};
+	
 
 /** Array of MMU fault status areas. */
@@ -405,5 +406,5 @@
 	uint64_t errno =  __hypercall_fast3(MMU_DEMAP_ALL, 0, 0,
 		MMU_FLAG_DTLB | MMU_FLAG_ITLB);
-	if (errno != HV_EOK) {
+	if (errno != EOK) {
 		panic("Error code = %d.\n", errno);
 	}
Index: kernel/arch/sparc64/src/mm/sun4v/tsb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/tsb.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/mm/sun4v/tsb.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2006 Jakub Jermar
- * Copyright (c) 2009 Pavel Rimsky
  * All rights reserved.
  *
@@ -35,5 +34,4 @@
 
 #include <arch/mm/tsb.h>
-#include <arch/mm/pagesize.h>
 #include <arch/mm/tlb.h>
 #include <arch/mm/page.h>
@@ -51,27 +49,30 @@
  * portions of both TSBs are invalidated at a time.
  *
- * @param as	Address space.
- * @param page 	First page to invalidate in TSB.
- * @param pages Number of pages to invalidate. Value of (count_t) -1 means the
- * 		whole TSB.
+ * @param as Address space.
+ * @param page First page to invalidate in TSB.
+ * @param pages Number of pages to invalidate. Value of (size_t) -1 means the
+ * 	whole TSB.
  */
 void tsb_invalidate(as_t *as, uintptr_t page, size_t pages)
 {
-	size_t i0, i;
+	size_t i0;
+	size_t i;
 	size_t cnt;
 	
-	ASSERT(as->arch.tsb_description.tsb_base);
+	ASSERT(as->arch.itsb && as->arch.dtsb);
 	
 	i0 = (page >> MMU_PAGE_WIDTH) & TSB_INDEX_MASK;
-	ASSERT(i0 < TSB_ENTRY_COUNT);
+	ASSERT(i0 < ITSB_ENTRY_COUNT && i0 < DTSB_ENTRY_COUNT);
 
-	if (pages == (size_t) - 1 || (pages) > TSB_ENTRY_COUNT)
-		cnt = TSB_ENTRY_COUNT;
+	if (pages == (size_t) -1 || (pages * 2) > ITSB_ENTRY_COUNT)
+		cnt = ITSB_ENTRY_COUNT;
 	else
-		cnt = pages;
+		cnt = pages * 2;
 	
 	for (i = 0; i < cnt; i++) {
-		((tsb_entry_t *) PA2KA(as->arch.tsb_description.tsb_base))[
-			(i0 + i) & (TSB_ENTRY_COUNT - 1)].data.v = false;
+		as->arch.itsb[(i0 + i) & (ITSB_ENTRY_COUNT - 1)].tag.invalid =
+		    true;
+		as->arch.dtsb[(i0 + i) & (DTSB_ENTRY_COUNT - 1)].tag.invalid =
+		    true;
 	}
 }
@@ -80,15 +81,19 @@
  *
  * @param t 	Software PTE.
+ * @param index	Zero if lower 8K-subpage, one if higher 8K subpage.
  */
-void itsb_pte_copy(pte_t *t)
+void itsb_pte_copy(pte_t *t, size_t index)
 {
+#if 0
 	as_t *as;
 	tsb_entry_t *tsb;
 	size_t entry;
 
+	ASSERT(index <= 1);
+	
 	as = t->as;
-	entry = (t->page >> MMU_PAGE_WIDTH) & TSB_INDEX_MASK; 
-	ASSERT(entry < TSB_ENTRY_COUNT);
-	tsb = &((tsb_entry_t *) PA2KA(as->arch.tsb_description.tsb_base))[entry];
+	entry = ((t->page >> MMU_PAGE_WIDTH) + index) & TSB_INDEX_MASK; 
+	ASSERT(entry < ITSB_ENTRY_COUNT);
+	tsb = &as->arch.itsb[entry];
 
 	/*
@@ -98,25 +103,24 @@
 	 */
 
-	tsb->data.v = false;
+	tsb->tag.invalid = true;	/* invalidate the entry
+					 * (tag target has this
+					 * set to 0) */
 
 	write_barrier();
 
+	tsb->tag.context = as->asid;
+	/* the shift is bigger than PAGE_WIDTH, do not bother with index  */
 	tsb->tag.va_tag = t->page >> VA_TAG_PAGE_SHIFT;
-
 	tsb->data.value = 0;
-	tsb->data.nfo = false;
-	tsb->data.ra = t->frame >> MMU_FRAME_WIDTH;
-	tsb->data.ie = false;
-	tsb->data.e = false;
+	tsb->data.size = PAGESIZE_8K;
+	tsb->data.pfn = (t->frame >> MMU_FRAME_WIDTH) + index;
 	tsb->data.cp = t->c;	/* cp as cache in phys.-idxed, c as cacheable */
-	tsb->data.cv = false;
 	tsb->data.p = t->k;	/* p as privileged, k as kernel */
-	tsb->data.x = true;
-	tsb->data.w = false;
-	tsb->data.size = PAGESIZE_8K;
+	tsb->data.v = t->p;	/* v as valid, p as present */
 	
 	write_barrier();
 	
-	tsb->data.v = t->p;	/* v as valid, p as present */
+	tsb->tag.invalid = false;	/* mark the entry as valid */
+#endif
 }
 
@@ -124,16 +128,20 @@
  *
  * @param t	Software PTE.
+ * @param index	Zero if lower 8K-subpage, one if higher 8K-subpage.
  * @param ro	If true, the mapping is copied read-only.
  */
-void dtsb_pte_copy(pte_t *t, bool ro)
+void dtsb_pte_copy(pte_t *t, size_t index, bool ro)
 {
+#if 0
 	as_t *as;
 	tsb_entry_t *tsb;
 	size_t entry;
+	
+	ASSERT(index <= 1);
 
 	as = t->as;
-	entry = (t->page >> MMU_PAGE_WIDTH) & TSB_INDEX_MASK; 
-	ASSERT(entry < TSB_ENTRY_COUNT);
-	tsb = &((tsb_entry_t *) PA2KA(as->arch.tsb_description.tsb_base))[entry];
+	entry = ((t->page >> MMU_PAGE_WIDTH) + index) & TSB_INDEX_MASK;
+	ASSERT(entry < DTSB_ENTRY_COUNT);
+	tsb = &as->arch.dtsb[entry];
 
 	/*
@@ -143,29 +151,31 @@
 	 */
 
-	tsb->data.v = false;
+	tsb->tag.invalid = true;	/* invalidate the entry
+					 * (tag target has this
+					 * set to 0) */
 
 	write_barrier();
 
+	tsb->tag.context = as->asid;
+	/* the shift is bigger than PAGE_WIDTH, do not bother with index */
 	tsb->tag.va_tag = t->page >> VA_TAG_PAGE_SHIFT;
-
 	tsb->data.value = 0;
-	tsb->data.nfo = false;
-	tsb->data.ra = t->frame >> MMU_FRAME_WIDTH;
-	tsb->data.ie = false;
-	tsb->data.e = false;
-	tsb->data.cp = t->c;	/* cp as cache in phys.-idxed, c as cacheable */
+	tsb->data.size = PAGESIZE_8K;
+	tsb->data.pfn = (t->frame >> MMU_FRAME_WIDTH) + index;
+	tsb->data.cp = t->c;
 #ifdef CONFIG_VIRT_IDX_DCACHE
 	tsb->data.cv = t->c;
 #endif /* CONFIG_VIRT_IDX_DCACHE */
-	tsb->data.p = t->k;	/* p as privileged, k as kernel */
-	tsb->data.x = true;
+	tsb->data.p = t->k;		/* p as privileged */
 	tsb->data.w = ro ? false : t->w;
-	tsb->data.size = PAGESIZE_8K;
+	tsb->data.v = t->p;
 	
 	write_barrier();
 	
-	tsb->data.v = t->p;	/* v as valid, p as present */
+	tsb->tag.invalid = false;	/* mark the entry as valid */
+#endif
 }
 
 /** @}
  */
+
Index: kernel/arch/sparc64/src/smp/ipi.c
===================================================================
--- kernel/arch/sparc64/src/smp/ipi.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
+++ kernel/arch/sparc64/src/smp/ipi.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -0,0 +1,174 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup sparc64	
+ * @{
+ */
+/** @file
+ */
+
+#include <smp/ipi.h>
+#include <cpu.h>
+#include <arch.h>
+#include <arch/cpu.h>
+#include <arch/asm.h>
+#include <config.h>
+#include <mm/tlb.h>
+#include <arch/interrupt.h>
+#include <arch/trap/interrupt.h>
+#include <arch/barrier.h>
+#include <preemption.h>
+#include <time/delay.h>
+#include <panic.h>
+
+/** Set the contents of the outgoing interrupt vector data.
+ *
+ * The first data item (data 0) will be set to the value of func, the
+ * rest of the vector will contain zeros.
+ *
+ * This is a helper function used from within the cross_call function.
+ *
+ * @param func value the first data item of the vector will be set to
+ */
+static inline void set_intr_w_data(void (* func)(void))
+{
+#if defined (US)
+	asi_u64_write(ASI_INTR_W, ASI_UDB_INTR_W_DATA_0, (uintptr_t) func);
+	asi_u64_write(ASI_INTR_W, ASI_UDB_INTR_W_DATA_1, 0);
+	asi_u64_write(ASI_INTR_W, ASI_UDB_INTR_W_DATA_2, 0);
+#elif defined (US3)
+	asi_u64_write(ASI_INTR_W, VA_INTR_W_DATA_0, (uintptr_t)	func);
+	asi_u64_write(ASI_INTR_W, VA_INTR_W_DATA_1, 0);
+	asi_u64_write(ASI_INTR_W, VA_INTR_W_DATA_2, 0);
+	asi_u64_write(ASI_INTR_W, VA_INTR_W_DATA_3, 0);
+	asi_u64_write(ASI_INTR_W, VA_INTR_W_DATA_4, 0);
+	asi_u64_write(ASI_INTR_W, VA_INTR_W_DATA_5, 0);
+	asi_u64_write(ASI_INTR_W, VA_INTR_W_DATA_6, 0);
+	asi_u64_write(ASI_INTR_W, VA_INTR_W_DATA_7, 0);
+#endif
+}
+
+/** Invoke function on another processor.
+ *
+ * Currently, only functions without arguments are supported.
+ * Supporting more arguments in the future should be no big deal.
+ *
+ * Interrupts must be disabled prior to this call.
+ *
+ * @param mid MID of the target processor.
+ * @param func Function to be invoked.
+ */
+static void cross_call(int mid, void (* func)(void))
+{
+	uint64_t status;
+	bool done;
+
+	/*
+	 * This function might enable interrupts for a while.
+	 * In order to prevent migration to another processor,
+	 * we explicitly disable preemption.
+	 */
+	
+	preemption_disable();
+	
+	status = asi_u64_read(ASI_INTR_DISPATCH_STATUS, 0);
+	if (status & INTR_DISPATCH_STATUS_BUSY)
+		panic("Interrupt Dispatch Status busy bit set.");
+	
+	ASSERT(!(pstate_read() & PSTATE_IE_BIT));
+	
+	do {
+		set_intr_w_data(func);
+		asi_u64_write(ASI_INTR_W,
+		    (mid << INTR_VEC_DISPATCH_MID_SHIFT) |
+		    VA_INTR_W_DISPATCH, 0);
+	
+		membar();
+		
+		do {
+			status = asi_u64_read(ASI_INTR_DISPATCH_STATUS, 0);
+		} while (status & INTR_DISPATCH_STATUS_BUSY);
+		
+		done = !(status & INTR_DISPATCH_STATUS_NACK);
+		if (!done) {
+			/*
+			 * Prevent deadlock.
+			 */			
+			(void) interrupts_enable();
+			delay(20 + (tick_read() & 0xff));
+			(void) interrupts_disable();
+		}
+	} while (done);
+	
+	preemption_enable();
+}
+
+/*
+ * Deliver IPI to all processors except the current one.
+ *
+ * The sparc64 architecture does not support any group addressing
+ * which is found, for instance, on ia32 and amd64. Therefore we
+ * need to simulate the broadcast by sending the message to
+ * all target processors step by step.
+ *
+ * We assume that interrupts are disabled.
+ *
+ * @param ipi IPI number.
+ */
+void ipi_broadcast_arch(int ipi)
+{
+	unsigned int i;
+	
+	void (* func)(void);
+	
+	switch (ipi) {
+	case IPI_TLB_SHOOTDOWN:
+		func = tlb_shootdown_ipi_recv;
+		break;
+	default:
+		panic("Unknown IPI (%d).", ipi);
+		break;
+	}
+	
+	/*
+	 * As long as we don't support hot-plugging
+	 * or hot-unplugging of CPUs, we can walk
+	 * the cpus array and read processor's MID
+	 * without locking.
+	 */
+	
+	for (i = 0; i < config.cpu_active; i++) {
+		if (&cpus[i] == CPU)
+			continue;		/* skip the current CPU */
+
+		cross_call(cpus[i].arch.mid, func);
+	}
+}
+
+/** @}
+ */
Index: kernel/arch/sparc64/src/smp/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/smp.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
+++ kernel/arch/sparc64/src/smp/smp.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -0,0 +1,137 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup sparc64	
+ * @{
+ */
+/** @file
+ */
+
+#include <smp/smp.h>
+#include <genarch/ofw/ofw_tree.h>
+#include <cpu.h>
+#include <arch/cpu_family.h>
+#include <arch/cpu.h>
+#include <arch.h>
+#include <config.h>
+#include <macros.h>
+#include <arch/types.h>
+#include <synch/synch.h>
+#include <synch/waitq.h>
+#include <print.h>
+#include <arch/cpu_node.h>
+
+/**
+ * This global variable is used to pick-up application processors
+ * from their active loop in start.S. When a processor looping in
+ * start.S sees that this variable contains its MID, it can
+ * proceed with its initialization.
+ *
+ * This variable is modified only by the bootstrap processor.
+ * Other processors access it read-only.
+ */
+volatile uint64_t waking_up_mid = (uint64_t) -1;
+
+/** Determine number of processors. */
+void smp_init(void)
+{
+	ofw_tree_node_t *node;
+	size_t cnt = 0;
+	
+	if (is_us() || is_us_iii()) {
+		node = ofw_tree_find_child_by_device_type(cpus_parent(), "cpu");
+		while (node) {
+			cnt++;
+			node = ofw_tree_find_peer_by_device_type(node, "cpu");
+		}
+	} else if (is_us_iv()) {
+		node = ofw_tree_find_child(cpus_parent(), "cmp");
+		while (node) {
+			cnt += 2;
+			node = ofw_tree_find_peer_by_name(node, "cmp");
+		}
+	}
+	
+	config.cpu_count = max(1, cnt);
+}
+
+/**
+ * Wakes up the CPU which is represented by the "node" OFW tree node.
+ * If "node" represents the current CPU, calling the function has
+ * no effect. 
+ */
+static void wakeup_cpu(ofw_tree_node_t *node)
+{
+	uint32_t mid;
+	ofw_tree_property_t *prop;
+		
+	/* 'upa-portid' for US, 'portid' for US-III, 'cpuid' for US-IV */
+	prop = ofw_tree_getprop(node, "upa-portid");
+	if ((!prop) || (!prop->value))
+		prop = ofw_tree_getprop(node, "portid");
+	if ((!prop) || (!prop->value))
+		prop = ofw_tree_getprop(node, "cpuid");
+		
+	if (!prop || prop->value == NULL)
+		return;
+		
+	mid = *((uint32_t *) prop->value);
+	if (CPU->arch.mid == mid)
+		return;
+
+	waking_up_mid = mid;
+		
+	if (waitq_sleep_timeout(&ap_completion_wq, 1000000, SYNCH_FLAGS_NONE) ==
+	    ESYNCH_TIMEOUT)
+		printf("%s: waiting for processor (mid = %" PRIu32
+		    ") timed out\n", __func__, mid);
+}
+
+/** Wake application processors up. */
+void kmp(void *arg)
+{
+	ofw_tree_node_t *node;
+	int i;
+	
+	if (is_us() || is_us_iii()) {
+		node = ofw_tree_find_child_by_device_type(cpus_parent(), "cpu");
+		for (i = 0; node;
+                     node = ofw_tree_find_peer_by_device_type(node, "cpu"), i++)
+			wakeup_cpu(node);
+	} else if (is_us_iv()) {
+		node = ofw_tree_find_child(cpus_parent(), "cmp");
+		while (node) {
+			wakeup_cpu(ofw_tree_find_child(node, "cpu@0"));
+			wakeup_cpu(ofw_tree_find_child(node, "cpu@1"));
+			node = ofw_tree_find_peer_by_name(node, "cmp");
+		}
+	}
+}
+
+/** @}
+ */
Index: kernel/arch/sparc64/src/sun4v/md.c
===================================================================
--- kernel/arch/sparc64/src/sun4v/md.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/sun4v/md.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -104,6 +104,6 @@
 static md_element_t *get_element(element_idx_t idx)
 {
-	return (md_element_t *) (mach_desc +
-	    sizeof(md_header_t) + idx * sizeof(md_element_t));
+	return (md_element_t *) (
+		mach_desc + sizeof(md_header_t) + idx * sizeof(md_element_t));
 }
 
@@ -114,5 +114,5 @@
 	uintptr_t name_offset = get_element(idx)->name_offset;
 	return (char *) mach_desc + sizeof(md_header_t) +
-	    md_header->node_blk_sz + name_offset;
+		md_header->node_blk_sz + name_offset;
 }
 
@@ -137,5 +137,5 @@
 		md_element_t *element = get_element(idx);
 		if (element->tag == PROP_VAL &&
-		    str_cmp(key, get_element_name(idx)) == 0) {
+				str_cmp(key, get_element_name(idx)) == 0) {
 			*result = element->d.val;
 			return true;
@@ -161,8 +161,8 @@
 		md_element_t *element = get_element(idx);
 		if (element->tag == PROP_DATA &&
-		    str_cmp(key, get_element_name(idx)) == 0) {
+				str_cmp(key, get_element_name(idx)) == 0) {
 			*result = (char *) mach_desc + sizeof(md_header_t) +
-			    md_header->node_blk_sz + md_header->name_blk_sz +
-			    element->d.y.data_offset;
+				md_header->node_blk_sz + md_header->name_blk_sz +
+				element->d.y.data_offset;
 			return true;
 		}
@@ -186,5 +186,5 @@
 		md_element_t *element = get_element(*it);
 		if (element->tag == PROP_ARC &&
-		    str_cmp("fwd", get_element_name(*it)) == 0) {
+				str_cmp("fwd", get_element_name(*it)) == 0) {
 			return true;
 		}
@@ -289,5 +289,5 @@
 
 		if (element->tag == NODE &&
-		    str_cmp(name, get_element_name(*node)) == 0) {
+				str_cmp(name, get_element_name(*node)) == 0) {
 			return true;
 		}
@@ -306,10 +306,10 @@
 {
 	uint64_t retval = __hypercall_fast2(MACH_DESC, KA2PA(mach_desc),
-	    MD_MAX_SIZE);
+		MD_MAX_SIZE);
 
 	retval = retval;
-	if (retval != HV_EOK) {
+	if (retval != EOK) {
 		printf("Could not retrieve machine description, error = %d.\n",
-		    retval);
+			retval);
 	}
 }
Index: kernel/arch/sparc64/src/sun4v/sparc64.c
===================================================================
--- kernel/arch/sparc64/src/sun4v/sparc64.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/sun4v/sparc64.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -50,4 +50,6 @@
 #include <ddi/irq.h>
 #include <string.h>
+
+//MH
 #include <arch/drivers/niagara.h>
 
Index: kernel/arch/sparc64/src/trap/exception.c
===================================================================
--- kernel/arch/sparc64/src/trap/exception.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/trap/exception.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -46,7 +46,9 @@
 void dump_istate(istate_t *istate)
 {
-	const char *tpcs = symtab_fmt_name_lookup(istate->tpc);
-	const char *tnpcs = symtab_fmt_name_lookup(istate->tnpc);
-	
+	char *tpcs, *tnpcs;
+
+	tpcs = symtab_fmt_name_lookup(istate->tpc);
+	tnpcs = symtab_fmt_name_lookup(istate->tnpc);
+
 	printf("TSTATE=%#" PRIx64 "\n", istate->tstate);
 	printf("TPC=%#" PRIx64 " (%s)\n", istate->tpc, tpcs);
@@ -160,5 +162,6 @@
 	fault_if_from_uspace(istate, "%s.", __func__);
 	dump_istate(istate);
-	describe_dmmu_fault();
+//MH
+//	dump_sfsr_and_sfar();
 	panic("%s.", __func__);
 }
Index: kernel/arch/sparc64/src/trap/interrupt.c
===================================================================
--- kernel/arch/sparc64/src/trap/interrupt.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/trap/interrupt.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2005 Jakub Jermar
- * Copyright (c) 2009 Pavel Rimsky
  * All rights reserved.
  *
@@ -35,6 +34,6 @@
 
 #include <arch/interrupt.h>
+#include <arch/sparc64.h>
 #include <arch/trap/interrupt.h>
-#include <arch/sparc64.h>
 #include <interrupt.h>
 #include <ddi/irq.h>
@@ -61,4 +60,65 @@
 	exc_register(n - 1, name, f);
 }
+
+/** Process hardware interrupt.
+ *
+ * @param n Ignored.
+ * @param istate Ignored.
+ */
+void interrupt(int n, istate_t *istate)
+{
+	uint64_t status;
+	uint64_t intrcv;
+	uint64_t data0;
+	status = asi_u64_read(ASI_INTR_DISPATCH_STATUS, 0);
+	if (status & (!INTR_DISPATCH_STATUS_BUSY))
+		panic("Interrupt Dispatch Status busy bit not set.");
+
+	intrcv = asi_u64_read(ASI_INTR_RECEIVE, 0);
+#if defined (US)
+	data0 = asi_u64_read(ASI_INTR_R, ASI_UDB_INTR_R_DATA_0);
+#elif defined (US3)
+	data0 = asi_u64_read(ASI_INTR_R, VA_INTR_R_DATA_0);
+#endif
+
+	irq_t *irq = irq_dispatch_and_lock(data0);
+	if (irq) {
+		/*
+		 * The IRQ handler was found.
+		 */
+		irq->handler(irq);
+		/*
+		 * See if there is a clear-interrupt-routine and call it.
+		 */
+		if (irq->cir) {
+			irq->cir(irq->cir_arg, irq->inr);
+		}
+		spinlock_unlock(&irq->lock);
+	} else if (data0 > config.base) {
+		/*
+		 * This is a cross-call.
+		 * data0 contains address of the kernel function.
+		 * We call the function only after we verify
+		 * it is one of the supported ones.
+		 */
+#ifdef CONFIG_SMP
+		if (data0 == (uintptr_t) tlb_shootdown_ipi_recv) {
+			tlb_shootdown_ipi_recv();
+		}
+#endif
+	} else {
+		/*
+		 * Spurious interrupt.
+		 */
+#ifdef CONFIG_DEBUG
+		printf("cpu%u: spurious interrupt (intrcv=%#" PRIx64
+		    ", data0=%#" PRIx64 ")\n", CPU->id, intrcv, data0);
+#endif
+	}
+
+	membar();
+	asi_u64_write(ASI_INTR_RECEIVE, 0, 0);
+}
+
 /** @}
  */
